package de.survivalprojekt.LS.Listeners;

import java.util.UUID;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerLoginEvent;

import de.survivalprojekt.LS.ServerManager;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.minimessage.MiniMessage;
import net.kyori.adventure.text.serializer.legacy.LegacyComponentSerializer;

public class PlayerListener implements Listener {
    @EventHandler
    public void onPlayerLogin(PlayerLoginEvent e) {
        Player pl = e.getPlayer();
        ServerManager inst = ServerManager.getInst();
        if (inst.getWartungsManager().getIsWartung()) {
            if (pl.hasPermission("lss.wartung.bypass")) {
                inst.getLogger().info(pl.getName() + " hat die Berechtigung 'lss.wartung.bypass' und darf joinen.");
                e.allow();
                return;
            }
            String kickMsg = inst.getWartungsManager().getKickMsg();
            MiniMessage miniMessage = MiniMessage.miniMessage();
            Component kickComponent = miniMessage.deserialize(kickMsg);

            // Spieler wird sauber gekickt ??? DEUTSCHKURS DF ?????
            e.disallow(PlayerLoginEvent.Result.KICK_OTHER,
                    LegacyComponentSerializer.legacySection().serialize(kickComponent));
            return;
        }
        if (inst.getWhitelistManager().getWhitelistEnabled()) {
            String uuid = pl.getUniqueId().toString();
            if (!inst.getWhitelistManager().isWhitelisted(UUID.fromString(uuid))) {
                String rawMessage = inst.getWhitelistManager().getMessage();
                MiniMessage miniMessage = MiniMessage.miniMessage();
                Component messageComponent = miniMessage.deserialize(rawMessage);
                e.disallow(PlayerLoginEvent.Result.KICK_OTHER,
                        LegacyComponentSerializer.legacySection().serialize(messageComponent));
            }
        }

    }
}
