package de.survivalprojekt.LS.Listeners;

import java.io.File;
import java.io.IOException;

import org.bukkit.Bukkit;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.server.ServerListPingEvent;

import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.minimessage.MiniMessage;
import net.kyori.adventure.text.serializer.legacy.LegacyComponentSerializer;

import de.survivalprojekt.LS.ServerManager;

public class ServerListListener implements Listener {
    @EventHandler
    public void onServerListPing(ServerListPingEvent event) {
        ServerManager inst = ServerManager.getInst();

        if(inst.getWartungsManager().getIsWartung()) {
            String wartung = inst.getWartungsManager().getMotd();
            MiniMessage miniMessage = MiniMessage.miniMessage();
            Component motdComponent = miniMessage.deserialize(wartung);
            event.setMotd(LegacyComponentSerializer.legacySection().serialize(motdComponent));
            event.setMaxPlayers(0);
            try {
                event.setServerIcon(null); // Zeigt kein Server-Icon
            } catch (Exception e) {
                inst.getLogger().warning("Konnte das Server-Icon nicht setzen: " + e.getMessage());
            }
            return;
        }
        
        String motd = inst.getMotdManager().getMotd();
        if (motd != null) {
            MiniMessage miniMessage = MiniMessage.miniMessage();
            Component motdComponent = miniMessage.deserialize(motd);
            event.setMotd(LegacyComponentSerializer.legacySection().serialize(motdComponent));
        }

        // Lade das Logo aus dem Logos-Ordner
        File logoFile = new File(inst.getDataFolder() + "/" + inst.getMotdManager().getFolderName() + "/"
                + inst.getMotdManager().getIconName());
        if (logoFile.exists()) {
            try {
                event.setServerIcon(Bukkit.loadServerIcon(logoFile));
            } catch (IOException e) {
                inst.getLogger().severe("Fehler beim Laden des Server-Icons: " + e.getMessage());
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        } else {
            inst.getLogger()
                    .warning("Das Logo 'server-icon.png' wurde im Logos-Ordner nicht gefunden.");
        }
    }
}
