package de.survivalprojekt.LS.Managers;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.StandardCopyOption;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import de.survivalprojekt.LS.ServerManager;

public class WartungsManager {

    File wartungsFile;
    FileConfiguration wartungsConfig;
    boolean isWartung;

    public WartungsManager() {
        initFile();
    }

    private void initFile() {
        ServerManager inst = ServerManager.getInst();
        /////// SETUP CONFIG ///////
        wartungsFile = new File(inst.getDataFolder(), "wartung.yml");
        if (!wartungsFile.exists()) {
            try (InputStream inputStream = inst.getResource("wartung.yml")) {
                if (inputStream != null) {
                    Files.copy(inputStream, wartungsFile.toPath(), StandardCopyOption.REPLACE_EXISTING);
                    inst.getLogger().info("Die Standard-Wartungs-Konfigurationsdatei wurde erstellt.");
                } else {
                    inst.getLogger().warning("Standart Wartungs-Konfigurationsdatei konnte nicht gefunden werden.");
                }
            } catch (IOException e) {
                inst.getLogger().severe("Fehler beim erstellen der Wartungs-Konfigurationsdatei: " + e.getMessage());
            }
        }
        wartungsConfig = YamlConfiguration.loadConfiguration(wartungsFile);
        isWartung = wartungsConfig.getBoolean("wartungsModus", false);
        ///// GIBT KEINEN GRUND JEDEN SCHEISS ZU LOGGEN /////
        /// DAFÜR GIBT ES FUCKING ERROR MESSAGES /////
        inst.getLogger().info("Wartungs-Konfiguration wurde <neu> geladen.");
    }

    public void reloadWartung() {
        initFile();
    }

    public void save() {
        wartungsConfig.set("wartungsModus", isWartung);
        try {
            wartungsConfig.save(wartungsFile);
        } catch (IOException e) {
            ServerManager.getInst().getLogger()
                    .severe("Fehler beim speichern der Wartungskonfigurationsdatei: " + e.getMessage());
        }
    }

    public String getMotd() {
        return wartungsConfig.getString("wartungsMotd");
    }

    public String getKickMsg() {
        return wartungsConfig.getString("kickMessage");
    }

    public boolean getIsWartung() {
        return this.isWartung;
    }

    public void setIsWartung(boolean value) {
        this.isWartung = value;
    }
}
