package de.survivalprojekt.LS.TabCompleters;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabCompleter;

import de.survivalprojekt.LS.ServerManager;

public class WhitelistCompleter implements TabCompleter {
    @Override
    public List<String> onTabComplete(
            CommandSender sender, Command command, String alias, String[] args) {
        List<String> completions = new ArrayList<>();
        ServerManager inst = ServerManager.getInst();
        if (command.getName().equalsIgnoreCase("whitelist")) {
            if (args.length == 1) {
                completions.add("add");
                completions.add("remove");
                completions.add("reload");
                completions.add("on");
                completions.add("off");
            } else if (args.length == 2) {
                if (args[0].equals("remove")) {
                    if (inst.getWhitelistManager().getWhitelistedPlayers() != null) {
                        for (String uuid : inst.getWhitelistManager().getWhitelistedPlayers()) {
                            String name = inst.getWhitelistManager().getWhitelistedPlayerName(uuid);
                            if (name != null) {
                                completions.add(name);
                            }
                        }
                    }
                }
            }
        }
        return completions;
    }
}
